﻿Imports System
Imports System.IO
Imports System.Net
Imports System.Net.Mail
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Forms

Public Class SmtpTestForm
    Inherits Form

    ' UI 控制項宣告
    Private grpServer As GroupBox
    Private lblServer As Label
    Private txtServer As TextBox
    Private lblPort As Label
    Private txtPort As TextBox
    Private chkSSL As CheckBox
    Private chkAuth As CheckBox

    Private grpAuth As GroupBox
    Private lblUsername As Label
    Private txtUsername As TextBox
    Private lblPassword As Label
    Private txtPassword As TextBox

    Private grpEmail As GroupBox
    Private lblFrom As Label
    Private txtFrom As TextBox
    Private lblTo As Label
    Private txtTo As TextBox
    Private lblSubject As Label
    Private txtSubject As TextBox
    Private lblBody As Label
    Private txtBody As TextBox

    Private grpOptions As GroupBox
    Private btnSmtpTest As Button
    Private btnSendTest As Button
    Private btnSaveSettings As Button
    Private btnLoadSettings As Button

    Private txtLog As TextBox

    ' 配置文件路徑
    Private ReadOnly ConfigFile As String = Path.Combine(Application.StartupPath, "smtp_config.ini")

    Public Sub New()
        InitializeComponent00()
        LoadSettings()
    End Sub

    Private Sub InitializeComponent00()
        ' 設定窗體屬性
        Me.Text = "內部郵件發送測試工具"
        Me.Size = New Size(700, 650)
        Me.StartPosition = FormStartPosition.CenterScreen
        Me.FormBorderStyle = FormBorderStyle.FixedDialog
        Me.MaximizeBox = False

        ' 伺服器配置區域
        grpServer = New GroupBox()
        grpServer.Text = "SMTP 伺服器設定"
        grpServer.Location = New Point(12, 12)
        grpServer.Size = New Size(320, 140)

        lblServer = New Label()
        lblServer.Text = "伺服器地址:"
        lblServer.Location = New Point(15, 30)
        lblServer.Size = New Size(100, 20)

        txtServer = New TextBox()
        txtServer.Location = New Point(120, 30)
        txtServer.Size = New Size(180, 23)
        txtServer.Text = "mail.yourcompany.com"

        lblPort = New Label()
        lblPort.Text = "伺服器端口:"
        lblPort.Location = New Point(15, 60)
        lblPort.Size = New Size(100, 20)

        txtPort = New TextBox()
        txtPort.Location = New Point(120, 60)
        txtPort.Size = New Size(180, 23)
        txtPort.Text = "25"

        chkSSL = New CheckBox()
        chkSSL.Text = "使用 SSL/TLS 加密連接"
        chkSSL.Location = New Point(15, 90)
        chkSSL.Size = New Size(200, 20)
        chkSSL.Checked = False

        chkAuth = New CheckBox()
        chkAuth.Text = "需要身份認證"
        chkAuth.Location = New Point(15, 110)
        chkAuth.Size = New Size(200, 20)
        chkAuth.Checked = True
        AddHandler chkAuth.CheckedChanged, AddressOf ChkAuth_CheckedChanged

        grpServer.Controls.Add(lblServer)
        grpServer.Controls.Add(txtServer)
        grpServer.Controls.Add(lblPort)
        grpServer.Controls.Add(txtPort)
        grpServer.Controls.Add(chkSSL)
        grpServer.Controls.Add(chkAuth)

        ' 認證配置區域
        grpAuth = New GroupBox()
        grpAuth.Text = "認證信息"
        grpAuth.Location = New Point(350, 12)
        grpAuth.Size = New Size(320, 140)

        lblUsername = New Label()
        lblUsername.Text = "用戶名:"
        lblUsername.Location = New Point(15, 30)
        lblUsername.Size = New Size(100, 20)

        txtUsername = New TextBox()
        txtUsername.Location = New Point(120, 30)
        txtUsername.Size = New Size(180, 23)
        txtUsername.Text = "user@yourcompany.com"

        lblPassword = New Label()
        lblPassword.Text = "密碼:"
        lblPassword.Location = New Point(15, 60)
        lblPassword.Size = New Size(100, 20)

        txtPassword = New TextBox()
        txtPassword.Location = New Point(120, 60)
        txtPassword.Size = New Size(180, 23)
        txtPassword.PasswordChar = "*"c

        grpAuth.Controls.Add(lblUsername)
        grpAuth.Controls.Add(txtUsername)
        grpAuth.Controls.Add(lblPassword)
        grpAuth.Controls.Add(txtPassword)

        ' 郵件內容區域
        grpEmail = New GroupBox()
        grpEmail.Text = "郵件內容"
        grpEmail.Location = New Point(12, 160)
        grpEmail.Size = New Size(658, 220)

        lblFrom = New Label()
        lblFrom.Text = "發件人:"
        lblFrom.Location = New Point(15, 30)
        lblFrom.Size = New Size(100, 20)

        txtFrom = New TextBox()
        txtFrom.Location = New Point(120, 30)
        txtFrom.Size = New Size(520, 23)
        txtFrom.Text = "alerts@yourcompany.com"

        lblTo = New Label()
        lblTo.Text = "收件人:"
        lblTo.Location = New Point(15, 60)
        lblTo.Size = New Size(100, 20)

        txtTo = New TextBox()
        txtTo.Location = New Point(120, 60)
        txtTo.Size = New Size(520, 23)
        txtTo.Text = "recipient@yourcompany.com"

        lblSubject = New Label()
        lblSubject.Text = "主旨:"
        lblSubject.Location = New Point(15, 90)
        lblSubject.Size = New Size(100, 20)

        txtSubject = New TextBox()
        txtSubject.Location = New Point(120, 90)
        txtSubject.Size = New Size(520, 23)
        txtSubject.Text = "測試郵件"

        lblBody = New Label()
        lblBody.Text = "內容:"
        lblBody.Location = New Point(15, 120)
        lblBody.Size = New Size(100, 20)

        txtBody = New TextBox()
        txtBody.Location = New Point(120, 120)
        txtBody.Size = New Size(520, 80)
        txtBody.Multiline = True
        txtBody.ScrollBars = ScrollBars.Vertical
        txtBody.Text = "這是一封測試郵件，用於驗證 SMTP 功能。" & vbCrLf & vbCrLf & "發送時間: " & DateTime.Now.ToString()

        grpEmail.Controls.Add(lblFrom)
        grpEmail.Controls.Add(txtFrom)
        grpEmail.Controls.Add(lblTo)
        grpEmail.Controls.Add(txtTo)
        grpEmail.Controls.Add(lblSubject)
        grpEmail.Controls.Add(txtSubject)
        grpEmail.Controls.Add(lblBody)
        grpEmail.Controls.Add(txtBody)

        ' 操作按鈕區域
        grpOptions = New GroupBox()
        grpOptions.Text = "操作"
        grpOptions.Location = New Point(12, 390)
        grpOptions.Size = New Size(658, 70)

        btnSmtpTest = New Button()
        btnSmtpTest.Text = "測試 SMTP 連接"
        btnSmtpTest.Location = New Point(15, 25)
        btnSmtpTest.Size = New Size(150, 30)
        AddHandler btnSmtpTest.Click, AddressOf BtnSmtpTest_Click

        btnSendTest = New Button()
        btnSendTest.Text = "發送測試郵件"
        btnSendTest.Location = New Point(175, 25)
        btnSendTest.Size = New Size(150, 30)
        AddHandler btnSendTest.Click, AddressOf BtnSendTest_Click

        btnSaveSettings = New Button()
        btnSaveSettings.Text = "保存設定"
        btnSaveSettings.Location = New Point(335, 25)
        btnSaveSettings.Size = New Size(150, 30)
        AddHandler btnSaveSettings.Click, AddressOf BtnSaveSettings_Click

        btnLoadSettings = New Button()
        btnLoadSettings.Text = "加載設定"
        btnLoadSettings.Location = New Point(495, 25)
        btnLoadSettings.Size = New Size(150, 30)
        AddHandler btnLoadSettings.Click, AddressOf BtnLoadSettings_Click

        grpOptions.Controls.Add(btnSmtpTest)
        grpOptions.Controls.Add(btnSendTest)
        grpOptions.Controls.Add(btnSaveSettings)
        grpOptions.Controls.Add(btnLoadSettings)

        ' 日誌區域
        txtLog = New TextBox()
        txtLog.Multiline = True
        txtLog.ScrollBars = ScrollBars.Both
        txtLog.ReadOnly = True
        txtLog.Location = New Point(12, 470)
        txtLog.Size = New Size(658, 130)
        txtLog.BackColor = Color.FromArgb(240, 240, 240)

        ' 添加控件到窗體
        Me.Controls.Add(grpServer)
        Me.Controls.Add(grpAuth)
        Me.Controls.Add(grpEmail)
        Me.Controls.Add(grpOptions)
        Me.Controls.Add(txtLog)

        ' 初始化界面狀態
        UpdateAuthUIState()
    End Sub

    Private Sub ChkAuth_CheckedChanged(sender As Object, e As EventArgs)
        UpdateAuthUIState()
    End Sub

    Private Sub UpdateAuthUIState()
        ' 根據是否需要認證來啟用/禁用認證信息輸入
        grpAuth.Enabled = chkAuth.Checked
    End Sub

    Private Sub BtnSmtpTest_Click(sender As Object, e As EventArgs)
        LogMessage("開始測試 SMTP 連接...")
        TestSmtpConnection()
    End Sub

    Private Async Sub BtnSendTest_Click(sender As Object, e As EventArgs)
        LogMessage("開始發送測試郵件...")

        ' 更新郵件內容中的時間戳
        If Not txtBody.Text.Contains("發送時間:") Then
            txtBody.Text &= vbCrLf & vbCrLf & "發送時間: "
        End If

        txtBody.Text = txtBody.Text.Replace(txtBody.Text.Substring(txtBody.Text.IndexOf("發送時間:")),
                                          "發送時間: " & DateTime.Now.ToString())

        ' 發送測試郵件
        Await SendTestEmailAsync()
    End Sub

    Private Sub BtnSaveSettings_Click(sender As Object, e As EventArgs)
        SaveSettings()
    End Sub

    Private Sub BtnLoadSettings_Click(sender As Object, e As EventArgs)
        LoadSettings()
    End Sub

    Private Sub SaveSettings()
        Try
            Using writer As New StreamWriter(ConfigFile, False)
                writer.WriteLine("Server=" & txtServer.Text)
                writer.WriteLine("Port=" & txtPort.Text)
                writer.WriteLine("SSL=" & chkSSL.Checked.ToString())
                writer.WriteLine("RequireAuth=" & chkAuth.Checked.ToString())
                writer.WriteLine("Username=" & txtUsername.Text)
                ' 注意：出於安全考慮，密碼不會以明文保存
                ' 實際應用中應使用安全的加密方式存儲密碼
                ' 這裡僅為演示，使用簡單的編碼
                Dim encodedPassword As String = Convert.ToBase64String(Encoding.UTF8.GetBytes(txtPassword.Text))
                writer.WriteLine("Password=" & encodedPassword)
                writer.WriteLine("From=" & txtFrom.Text)
                writer.WriteLine("To=" & txtTo.Text)
            End Using
            LogMessage("設定已保存到: " & ConfigFile)
        Catch ex As Exception
            LogMessage("保存設定失敗: " & ex.Message)
        End Try
    End Sub

    Private Sub LoadSettings()
        If Not File.Exists(ConfigFile) Then
            LogMessage("設定文件不存在，使用默認值")
            Return
        End If

        Try
            Dim settings As New Dictionary(Of String, String)()

            Using reader As New StreamReader(ConfigFile)
                While Not reader.EndOfStream
                    Dim line As String = reader.ReadLine()
                    If Not String.IsNullOrEmpty(line) AndAlso line.Contains("=") Then
                        Dim parts As String() = line.Split(New Char() {"="c}, 2)
                        If parts.Length = 2 Then
                            settings(parts(0)) = parts(1)
                        End If
                    End If
                End While
            End Using

            If settings.ContainsKey("Server") Then txtServer.Text = settings("Server")
            If settings.ContainsKey("Port") Then txtPort.Text = settings("Port")
            If settings.ContainsKey("SSL") Then chkSSL.Checked = Boolean.Parse(settings("SSL"))
            If settings.ContainsKey("RequireAuth") Then chkAuth.Checked = Boolean.Parse(settings("RequireAuth"))
            If settings.ContainsKey("Username") Then txtUsername.Text = settings("Username")
            If settings.ContainsKey("Password") Then
                ' 解碼密碼
                Try
                    Dim decodedBytes As Byte() = Convert.FromBase64String(settings("Password"))
                    txtPassword.Text = Encoding.UTF8.GetString(decodedBytes)
                Catch
                    txtPassword.Text = ""
                End Try
            End If
            If settings.ContainsKey("From") Then txtFrom.Text = settings("From")
            If settings.ContainsKey("To") Then txtTo.Text = settings("To")

            UpdateAuthUIState()
            LogMessage("設定已從文件加載: " & ConfigFile)
        Catch ex As Exception
            LogMessage("加載設定失敗: " & ex.Message)
        End Try
    End Sub

    Private Async Sub TestSmtpConnection()
        Dim server As String = txtServer.Text.Trim()
        Dim port As Integer

        If String.IsNullOrEmpty(server) Then
            LogMessage("錯誤: 請輸入 SMTP 伺服器地址")
            Return
        End If

        If Not Integer.TryParse(txtPort.Text, port) OrElse port <= 0 OrElse port > 65535 Then
            LogMessage("錯誤: 端口號無效，請輸入 1-65535 之間的數字")
            Return
        End If

        Try
            ' 首先嘗試 TCP 連接到指定端口
            LogMessage("嘗試連接到 " & server & ":" & port & "...")

            Await Task.Run(Sub()
                               Try
                                   Using client As New System.Net.Sockets.TcpClient()
                                       ' 嘗試連接，設置 5 秒超時
                                       Dim result As IAsyncResult = client.BeginConnect(server, port, Nothing, Nothing)
                                       Dim success As Boolean = result.AsyncWaitHandle.WaitOne(5000, True)

                                       If success Then
                                           Invoke(Sub() LogMessage("TCP 連接成功"))

                                           ' 如果成功連接，建立一個 SMTP 客戶端進行完整測試
                                           Invoke(Sub() LogMessage("嘗試 SMTP 協議測試..."))

                                           Using smtpClient As New SmtpClient(server, port)
                                               smtpClient.EnableSsl = chkSSL.Checked
                                               smtpClient.Timeout = 10000 ' 10 秒超時

                                               If chkAuth.Checked Then
                                                   smtpClient.Credentials = New NetworkCredential(txtUsername.Text, txtPassword.Text)
                                               End If

                                               ' 建立一個空郵件用於測試，不實際發送
                                               Dim testMessage As New MailMessage()
                                               testMessage.From = New MailAddress(txtFrom.Text)
                                               testMessage.Subject = "測試連接 (不會發送)"

                                               ' 不實際發送，只測試連接
                                               ' 這裡我們不調用 Send，而是只測試當前連接狀態
                                           End Using

                                           Invoke(Sub() LogMessage("SMTP 連接測試成功！伺服器連接正常。"))
                                       Else
                                           Invoke(Sub() LogMessage("錯誤: 無法連接到伺服器，連接超時"))
                                           client.Close()
                                       End If
                                   End Using
                               Catch ex As Exception
                                   Invoke(Sub() LogMessage("連接測試失敗: " & ex.Message))
                               End Try
                           End Sub)
        Catch ex As Exception
            LogMessage("測試過程出錯: " & ex.Message)
        End Try
    End Sub

    Private Async Function SendTestEmailAsync() As Task
        Dim server As String = txtServer.Text.Trim()
        Dim port As Integer

        If String.IsNullOrEmpty(server) Then
            LogMessage("錯誤: 請輸入 SMTP 伺服器地址")
            Return
        End If

        If Not Integer.TryParse(txtPort.Text, port) OrElse port <= 0 OrElse port > 65535 Then
            LogMessage("錯誤: 端口號無效，請輸入 1-65535 之間的數字")
            Return
        End If

        If String.IsNullOrEmpty(txtFrom.Text) Then
            LogMessage("錯誤: 請輸入發件人郵箱")
            Return
        End If

        If String.IsNullOrEmpty(txtTo.Text) Then
            LogMessage("錯誤: 請輸入收件人郵箱")
            Return
        End If

        Try
            LogMessage("準備發送郵件...")

            ' 使用 Task.Run 避免阻塞 UI 線程
            Await Task.Run(Sub()
                               Try
                                   Invoke(Sub() LogMessage("配置 SMTP 客戶端..."))

                                   ' 配置 SMTP 客戶端
                                   Using smtpClient As New SmtpClient(server, port)
                                       Invoke(Sub() LogMessage("設置 SMTP 參數..."))

                                       smtpClient.EnableSsl = chkSSL.Checked
                                       smtpClient.Timeout = 30000 ' 30 秒超時

                                       If chkAuth.Checked Then
                                           Invoke(Sub() LogMessage("使用認證..."))
                                           smtpClient.Credentials = New NetworkCredential(txtUsername.Text, txtPassword.Text)
                                       End If

                                       ' 創建郵件
                                       Invoke(Sub() LogMessage("創建郵件內容..."))

                                       Using message As New MailMessage()
                                           message.From = New MailAddress(txtFrom.Text)

                                           ' 處理多個收件人（以逗號或分號分隔）
                                           Dim toAddresses As String() = txtTo.Text.Split(New Char() {","c, ";"c}, StringSplitOptions.RemoveEmptyEntries)
                                           For Each address As String In toAddresses
                                               message.To.Add(address.Trim())
                                           Next

                                           message.Subject = txtSubject.Text
                                           message.Body = txtBody.Text
                                           message.BodyEncoding = Encoding.UTF8
                                           message.IsBodyHtml = False

                                           ' 詳細日誌記錄
                                           Invoke(Sub() LogMessage("發送至: " & String.Join(", ", toAddresses)))
                                           Invoke(Sub() LogMessage("主旨: " & txtSubject.Text))
                                           Invoke(Sub() LogMessage("正在發送郵件..."))

                                           ' 發送郵件
                                           smtpClient.Send(message)

                                           Invoke(Sub() LogMessage("郵件已成功發送！"))
                                       End Using
                                   End Using
                               Catch ex As Exception
                                   Invoke(Sub() LogMessageWithDetails("發送郵件失敗", ex))
                               End Try
                           End Sub)
        Catch ex As Exception
            LogMessage("發送過程出錯: " & ex.Message)
        End Try
    End Function

    Private Sub LogMessage(message As String)
        ' 確保在 UI 線程上執行
        If txtLog.InvokeRequired Then
            txtLog.Invoke(New Action(Of String)(AddressOf LogMessage), message)
            Return
        End If

        ' 添加時間戳並顯示消息
        Dim logEntry As String = DateTime.Now.ToString("[HH:mm:ss] ") & message
        txtLog.AppendText(logEntry & Environment.NewLine)

        ' 滾動到底部
        txtLog.SelectionStart = txtLog.Text.Length
        txtLog.ScrollToCaret()
    End Sub

    Private Sub LogMessageWithDetails(message As String, ex As Exception)
        LogMessage(message & ": " & ex.Message)

        ' 添加詳細的異常信息，包括內部異常
        If ex.InnerException IsNot Nothing Then
            LogMessage("內部錯誤: " & ex.InnerException.Message)
        End If

        ' 添加堆棧跟踪
        LogMessage("詳細信息: " & ex.ToString())
    End Sub

    Private Sub SaveDebugEmail(subject As String, body As String, recipients As String)
        Try
            ' 創建調試目錄
            Dim debugDir As String = Path.Combine(Application.StartupPath, "debug_emails")
            If Not Directory.Exists(debugDir) Then
                Directory.CreateDirectory(debugDir)
            End If

            ' 創建唯一文件名
            Dim filename As String = "email_" & DateTime.Now.ToString("yyyyMMdd_HHmmss") & ".txt"
            Dim filepath As String = Path.Combine(debugDir, filename)

            ' 保存郵件內容
            Using writer As New StreamWriter(filepath, False, Encoding.UTF8)
                writer.WriteLine("Date: " & DateTime.Now.ToString())
                writer.WriteLine("From: " & txtFrom.Text)
                writer.WriteLine("To: " & recipients)
                writer.WriteLine("Subject: " & subject)
                writer.WriteLine("-------------------------")
                writer.WriteLine(body)
            End Using

            LogMessage("已保存調試郵件到: " & filepath)
        Catch ex As Exception
            LogMessage("保存調試郵件失敗: " & ex.Message)
        End Try
    End Sub
End Class

Module Program
    Sub Main()
        Application.EnableVisualStyles()
        Application.SetCompatibleTextRenderingDefault(False)
        Application.Run(New SmtpTestForm())
    End Sub
End Module